#!/bin/bash

if [ -r /etc/sysconfig/laptop ]; then
    . /etc/sysconfig/laptop
fi

# cpu throttling
# cat /proc/acpi/processor/CPU0/throttling for more info
ACAD_THR=${ACAD_THR=0}
BATT_THR=${BATT_THR=2}

# spindown time for HD (man hdparm for valid values)
# I prefer 2 hours for acad and 20 seconds for batt
ACAD_HD=${ACAD_HD=244}
BATT_HD=${BATT_HD=4}

# ac/battery event handler

status=`awk '/^state: / { print $2 }' /proc/acpi/ac_adapter/*/state`

case $status in
        "on-line")
                echo "Switching to on line battery mode"
                /sbin/laptop-mode stop
                /sbin/hdparm -S $ACAD_HD /dev/hda > /dev/null 2>&1
                /sbin/hdparm -B 255 /dev/hda > /dev/null 2>&1
		echo "Setting CPU throttling to $ACAD_THR"
                echo -n $ACAD_THR > /proc/acpi/processor/CPU*/throttling
                exit 0
        ;;
        "off-line")
                echo "Switching to off line battery mode"
                /sbin/laptop-mode start
                /sbin/hdparm -S $BATT_HD /dev/hda > /dev/null 2>&1
                /sbin/hdparm -B 1 /dev/hda > /dev/null 2>&1
		echo "Setting CPU throttling to $BATT_THR"
		echo -n $BATT_THR > /proc/acpi/processor/CPU*/throttling
                exit 0
        ;;
esac
